﻿'=================================================================================================================
' * Compiled with Visual Studio 2010 Visual Basic
' * Copyright 2013 Microsoft Inc. All Rights Reserved.
' *
' * Please refer to Microsoft's licensing agreements for object code
' * produced with Visual Studio 2010.
' *
' * Unless required by applicable law or agreed to in writing, software
' * distributed under the License is distributed on an "AS IS" BASIS,
' * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
' * See the License for the specific language governing permissions and
' * limitations under the License.
' *
'=================================================================================================================
Imports CamBam
Imports CamBam.CAD
Imports CamBam.Geom
Imports CamBam.UI
Imports CamBam.Util
Imports CamBam.ThisApplication
Imports System
Imports System.Text
Imports System.Windows.Forms
Imports System.Drawing.Printing
Imports System.Drawing.Font
Imports System.IO


Public Class Form2
    Dim config As CamBam.CamBamConfig = CamBamConfig.Defaults
    Dim cbsyspath As String = config.SystemPath + "CBPrint.cfg"
    Dim readvalue As String

    '
    Private Sub Form2_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' 
        Me.Location = New Point(500, 100)

        Me.FormBorderStyle = BorderStyle.Fixed3D
        Me.ControlBox = False
        Me.Opacity = 1
        Me.Tag = 0
        cbsyspath = config.SystemPath + "CBPrint.cfg" ' get the 'encoded' CamBam system path
        cbsyspath = FileUtils.GetFullPath(cbsyspath)  ' convert to a full-text path




    End Sub
    Public Sub New()
        MyBase.New()



        InitializeComponent()
        TextTranslation.Translate(Me)

        Dim tagval As Integer
        cbsyspath = config.SystemPath + "CBPrint.cfg" ' get the 'encoded' CB system path
        cbsyspath = FileUtils.GetFullPath(cbsyspath)  ' decode to full text path

        ' because this is a 'try' clause, if the open fails, we'll say there's no config file, yet
        Try
            Dim tr As IO.TextReader = New IO.StreamReader(cbsyspath)  ' open the config file
            readvalue = tr.ReadLine  ' get the binary-encoded configuration value
            tr.Close() ' close the file
            tagval = (Convert.ToInt32(readvalue) And &H2F) ' make sure the cancel-operation flag is false!

            All.Checked = False       ' un-check all flags off before setting the form's checked values
            FixColor_select.Checked = False ' otherwise, this routine would 'or' the flags
            Scale_select.Checked = False
            Rotate_select.Checked = False
            BW_select.Checked = False

            If tagval And 32 Then All.Checked = True ' now set each checkbox according to the config value settings
            If tagval And 8 Then FixColor_select.Checked = True
            If tagval And 4 Then Scale_select.Checked = True
            If tagval And 2 Then Rotate_select.Checked = True
            If tagval And 1 Then BW_select.Checked = True

        Catch ex As Exception  ' ahah!  The open of the config file failed.  It must not exist
            ' we found no file, so set all to our defaults
            FixColor_select.Checked = True
            Scale_select.Checked = True
            Rotate_select.Checked = True
            BW_select.Checked = False
            All.Checked = False
            Area.Checked = True
        End Try
        Me.Select()  ' select the checkbox form as in focus and ready to accept clicks
    End Sub

    Private Sub Proceed_Button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Proceed_Button.Click
        ' enter here when everything has been selected, and the Proceed button has been clicked

        Dim TagValue As Integer = 0
        Dim append_flag As Boolean = False  ' true = append, false= overwrite  this flag is used in the 'try' below

        ' set the tag value to pass the settings back to form1
        If All.Checked = True Then TagValue = TagValue + 32
        If FixColor_select.Checked = True Then TagValue = TagValue + 8
        If Scale_select.Checked = True Then TagValue = TagValue + 4
        If Rotate_select.Checked = True Then TagValue = TagValue + 2
        If BW_select.Checked = True Then TagValue = TagValue + 1
        Me.Tag = TagValue

        ' Another try clause.  If this one fails, we have a serious problem.

        Try
            Dim tr As IO.TextWriter = New IO.StreamWriter(cbsyspath, append_flag) ' open the file for replacement
            tr.WriteLine(Str(TagValue)) ' write the current config value to it
            tr.Close() ' close the file
        Catch ex As Exception
            MsgBox("writing config file failed") ' This is bad!!
        End Try

        Me.Close() ' done with form2, so close the window
    End Sub
    Private Sub cancel_button_click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cancel_button.Click
        Dim TagValue As Integer = 16  ' if we cancelled printing, set the cancel flag true in the tag
        Me.Tag = TagValue
        Me.Close()  ' then close the form, passing this back to form1
    End Sub
End Class
